#RSS for Sivm and SMRS
#and
#Combinatorial solution for Fig. 3 with K= 2 and K= 4
#We obtained the best solution with K = 8, since all the vertices were selected and N = 7.
#library(geometry)
#ch=convhulln(Y)
#unique(as.vector(ch))
#  9 48 17 11 46  6 10
# sort(unique(as.vector(ch)))
#  6  9 10 11 17 46 48
# sort(an3[[1]]) #obtained with examples.R
# 6  9 10 11 14 17 46 48


#Loading needed functions and packages:
source("stepArchetypesMod.R")
source("stepArchetypoids.R")
source("Functions_to_calculate_real_archetypes_with_swap2.R")

library(archetypes)

#RSS for Sivm and SMRS with K=4
Y=read.table('Y.txt')
data=Y
huge=200
n <- ncol(t(data))

#RSS SiVM

 vect_arch_ini=c(6,46,24,10) #results from SiVM from matlab, see examples.R
      
      k <- length(vect_arch_ini)
      
      x_gvv <- rbind(t(data), rep(huge, n))
      
      zs <- x_gvv[, vect_arch_ini] 
      zs <- as.matrix(zs)
      alphas <- matrix(0, nrow = k, ncol = n)
      for (j in 1 : n){
        alphas[, j] = coef(nnls(zs, x_gvv[,j]))
      }
      
      resid <- zs %*% alphas - x_gvv
      
      auxrss=max(svd(resid)$d) / n
  

#RSS SMRS

vect_arch_ini=c(46,17,9,6) #results from SMRS from matlab, see examples.R
      
      k <- length(vect_arch_ini)
      
      x_gvv <- rbind(t(data), rep(huge, n))
      
      zs <- x_gvv[, vect_arch_ini] 
      zs <- as.matrix(zs)
      alphas <- matrix(0, nrow = k, ncol = n)
      for (j in 1 : n){
        alphas[, j] = coef(nnls(zs, x_gvv[,j]))
      }
      
      resid <- zs %*% alphas - x_gvv
      
      auxrss=max(svd(resid)$d) / n
  


#Combinatorial solutions
Y=read.table('Y.txt')
data=Y
huge=200
n <- ncol(t(data))

#Vectors to save the computational time used by each iteration.
time_iter <- list()       
time_ini <- Sys.time()
comp_time <- c()

rss <- 1e+06
for(i in 1 : (n-3)){
 cat("New iteration:")
 print(i)
 for(f in (i+1):(n-2)){
  for (g in (f+1) : (n-1)){
    for (h in (g+1) : n){ #NOTE: If we would like to compute four archetypes, we would have to add a fourth 
                          #loop and so on and so forth.
      vect_arch_ini=c(i,f,g,h)
      
      k <- length(vect_arch_ini)
      
      x_gvv <- rbind(t(data), rep(huge, n))
      
      zs <- x_gvv[, vect_arch_ini] 
      zs <- as.matrix(zs)
      alphas <- matrix(0, nrow = k, ncol = n)
      for (j in 1 : n){
        alphas[, j] = coef(nnls(zs, x_gvv[,j]))
      }
      
      resid <- zs %*% alphas - x_gvv
      
      auxrss=max(svd(resid)$d) / n
      if(auxrss < rss){
        rss <- auxrss
        mejor=vect_arch_ini
      }
      
    }
  }
  }
  
  time_iter[[i]] <- Sys.time()
  
  if(i == 1){
    comp_time[1] <- difftime(time_iter[[i]], time_ini, units = "mins")
    cat("Computational time in this iteration: \n")
    print(time_iter[[i]] - time_ini)
  }else{
    comp_time[i] <- difftime(time_iter[[i]], time_iter[[i - 1]], units = "mins")
    cat("Computational time in this iteration: \n")
    print(time_iter[[i]] - time_iter[[i - 1]])
  } 
  
  print(mejor)
  print(rss)
}
save(mejor,rss,file="best_Y.RData")
cat("End of the programm")

#con k=2

data=Y
huge=200
n <- ncol(t(data))
#Vectors to save the computational time used by each iteration.
time_iter <- list()       
time_ini <- Sys.time()
comp_time <- c()

rss <- 1e+06
for(i in 1 : (n-1)){
 cat("New iteration:")
 print(i)
     for (h in (i+1) : n){ #NOTE: If we would like to compute four archetypes, we would have to add a fourth 
                          #loop and so on and so forth.
      vect_arch_ini=c(i,h)
      
      k <- length(vect_arch_ini)
      
      x_gvv <- rbind(t(data), rep(huge, n))
      
      zs <- x_gvv[, vect_arch_ini] 
      zs <- as.matrix(zs)
      alphas <- matrix(0, nrow = k, ncol = n)
      for (j in 1 : n){
        alphas[, j] = coef(nnls(zs, x_gvv[,j]))
      }
      
      resid <- zs %*% alphas - x_gvv
      
      auxrss=max(svd(resid)$d) / n
      if(auxrss < rss){
        rss <- auxrss
        mejor=vect_arch_ini
      }
      
    
  
  }
  
  time_iter[[i]] <- Sys.time()
  
  if(i == 1){
    comp_time[1] <- difftime(time_iter[[i]], time_ini, units = "mins")
    cat("Computational time in this iteration: \n")
    print(time_iter[[i]] - time_ini)
  }else{
    comp_time[i] <- difftime(time_iter[[i]], time_iter[[i - 1]], units = "mins")
    cat("Computational time in this iteration: \n")
    print(time_iter[[i]] - time_iter[[i - 1]])
  } 
  
  print(mejor)
  print(rss)
}
save(mejor,rss,file="best_Y2.RData")
cat("End of the programm")


