#Second experiment of the supplementary material of the paper: 
#Archetypoids: a new approach to define representative archetypal data



library(MASS)
library(archetypes)

#Loading needed functions and packages:
source("stepArchetypesMod.R")
source("stepArchetypoids.R")
source("Functions_to_calculate_real_archetypes_with_swap2.R")

mu=4

a1=matrix(0,nrow=mu*6,ncol=mu*6)
a2=matrix(0,nrow=mu*6,ncol=mu*6)
a3=matrix(0,nrow=mu*6,ncol=mu*6)

f=mu*6/3
f2=mu*6/2
f3=mu

a2[,(f+1):(2*f)]=1
a1=a2
a3=a2
a2[,(f+1-mu):(2*f+mu)]=1
a2[1:mu,]=0
a2[(mu*5+1):(mu*6),]=0
a3[(f2+1):(mu*6),(f3+1):f]=1

a3[(f2+1):(mu*6),(2*f+1):(2*f+mu)]=1
a3[(mu*6-mu+1):(mu*6),1:mu]=1
a3[(mu*6-mu+1):(mu*6),(mu*6-mu+1):(mu*6)]=1
a1=a3
a1[1:f2,(f3+1):f]=1

a1[1:f2,(2*f+1):(2*f+mu)]=1
a1[1:mu,1:mu]=1
a1[1:mu,(mu*6-mu+1):(mu*6)]=1
a1[(f2-mu+1):(f2+mu),(f3+1):f]=0
a1[(f2-mu+1):(f2+mu),(2*f+1):(2*f+mu)]=0

E=cbind(as.vector(a1),as.vector(a2),as.vector(a3))




#figure of archetypes
 par(mfcol=c(1,3))
for (i in 1:3){
m=matrix(E[,i],ncol=mu*6,nrow=mu*6,byrow=F)
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#figure of a sample of 10 observations

library(MCMCpack)
#number obervations
n=100
#alpha
alpha=0.8
#archetypes
K=3
#dimension vector
d=mu*6*mu*6
#sigma, noise
s=0.1 #
sp=0.05

d1=dim(E)
set.seed(1)
data=matrix(0,nrow=n,ncol=d)

for (i in 1:n){
hi=rdirichlet(1, rep(alpha,K))
Er=E
ru=runif(d1[1]*d1[2])
rum=matrix(ru,nrow=d1[1],ncol=d1[2])
Er[rum<sp/2]=0
Er[rum>= sp/2 & rum<sp]=1
pro=Er%*%t(hi)
data[i,]=(pro+rnorm(d,sd=s))>0.5 #binarize
}

#Figure sample 10
set.seed(2013)
 sa=sample(1:100,10)
 ej10=t(data[sa,])
#figure de 10 datos
 par(mfcol=c(2,5))
for (i in 1:10){
m=matrix(ej10[,i],ncol=6*mu,nrow=6*mu,byrow=F) #OJO que no s si ser byrow
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#Distance
dd=matrix(0,nrow=n,ncol=n)
for (i in 1:(n-1)){
m1=data[i,]

for (j in i:n){
m2=data[j,]

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

dd[i,j]=eq11
dd[j,i]=dd[i,j]
}
}

#Distances to nearest observations to E: MM
K=3

dot=matrix(0,nrow=n,ncol=K)
for (i in 1:n){

m1=data[i,]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

dot[i,j]=eq11

}
}

c(min(dot[,1]),min(dot[,2]),min(dot[,3]))

 c(which.min(dot[,1]),which.min(dot[,2]),which.min(dot[,3]))
# 44  6 10

# sort(dot[,1])
# sort(dot[,2])
# sort(dot[,3])

#RAW data

x=data
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid


# 87 59 10



deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))


#cmdscale
md=cmdscale(dd,k=2,eig=T)

cumsum(md$eig^2/sum(md$eig^2))

 x=md$points
 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids

 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid


deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   
deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))
 c(which.min(deon[,1]),which.min(deon[,2]),which.min(deon[,3]))


 
 #83 33 88
 
 #Sammon
 
 
xs=sammon(dd,k=2)

 x=xs$points
 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids

 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid

 
 deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))
 c(which.min(deon[,1]),which.min(deon[,2]),which.min(deon[,3]))
 
 # 33 23 83
 
#Isomds


xsm=isoMDS(dd,k=2)

x=xsm$points
 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids


 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))
 c(which.min(deon[,1]),which.min(deon[,2]),which.min(deon[,3]))
 
#23 83 14

#h-plot
p=princomp(dd)
v=p$loadings
pr=p$sdev
pv=cbind(pr[1]*v[1:(n),1],pr[2]*v[1:(n),2])


cumsum(c(pr[1]^4,pr[2]^4))/sum(pr^4) #first and second
x=pv
norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids


 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid


deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))
 c(which.min(deon[,1]),which.min(deon[,2]),which.min(deon[,3]))
 
 #44 33 52


#LLE
library(lle)
calc_k(dd,m=2)

set.seed(2014)
r=lle(dd,m=2,k=9)
x=r$Y
norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids

 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid



deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))
 c(which.min(deon[,1]),which.min(deon[,2]),which.min(deon[,3]))
 
 #55 26 10

#isomap
library(vegan)

im=isomap(dd, ndim=2, k=9)
x=im$points

norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids

 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid


deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))
 c(which.min(deon[,1]),which.min(deon[,2]),which.min(deon[,3]))
 
#40 22 39

#Difussion map
library(diffusionMap)

df=diffuse(dd,neigen=2)
x=df$X

norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which_alpha archetypoids

 ini_arch=c()
 for (j in 1:3){
 ini_arch[j]=which.max(ai$betas[j,])
 }
 
temp <- realArchetypes(x,huge = 200, 3, ini_arch) #which beta archetypoid


deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   

deon[i,j]=eq11

}
}

c(min(deon[,1]),min(deon[,2]),min(deon[,3]))
 c(which.min(deon[,1]),which.min(deon[,2]),which.min(deon[,3]))

# 83 14 23


#Figure with archetypoids for each method

#nearest individuals to original:MM
windows()
 par(mfcol=c(1,3))
 sa=c(44,6,10)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#RAW
windows()
 par(mfcol=c(1,3))
 sa=c(87, 59 ,10)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#h-plot
windows()
 par(mfcol=c(1,3))
 sa=c(44, 33, 52)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#lle
windows()
 par(mfcol=c(1,3))
 sa=c(55, 26 ,10)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#cmds
windows()
 par(mfcol=c(1,3))
 sa=c(83 ,33 ,88)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#Sammon
windows()
 par(mfcol=c(1,3))
 sa=c( 83,33, 23)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#Isomds and DIF
windows()
 par(mfcol=c(1,3))
 sa=c(83, 14, 23)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

#Isomap
windows()
 par(mfcol=c(1,3))
 sa=c(40, 22 ,39)
 ea=t(data[sa,]) 
for (i in 1:3){
m=matrix(ea[,i],ncol=6*mu,nrow=6*mu,byrow=F) 
image(t(m)[,ncol(m):1],col=1:0,axes=F)
 box()
}

######################
#Experiment replicated 50 times

re=50

mnmds=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con mds
mwmds=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con mds


mnsa=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con sammon
mwsa=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con sammon


mniso=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con isomds
mwiso=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con isomds


mnh=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con hplot
mwh=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con hplot


mno=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con raw data
mwo=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con raw data

mt=matrix(0,nrow=re,ncol=K) #distancia de todos datos a E original con raw data


mnlle=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con lle
mwlle=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con lle


mnim=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con isomap
mwim=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con isomap


mnd=matrix(0,nrow=re,ncol=K) #distancia de archetypoid nearest a E original con DIF
mwd=matrix(0,nrow=re,ncol=K) #distancia de archetypoid which alpha a E original con DIF




for (RE in 1:re){
set.seed(RE)
data=matrix(0,nrow=n,ncol=d)

for (i in 1:n){
hi=rdirichlet(1, rep(alpha,K))
Er=E
ru=runif(d1[1]*d1[2])
rum=matrix(ru,nrow=d1[1],ncol=d1[2])
Er[rum<sp/2]=0
Er[rum>= sp/2 & rum<sp]=1
pro=Er%*%t(hi)
data[i,]=(pro+rnorm(d,sd=s))>0.5 #binarize
}


dd=matrix(0,nrow=n,ncol=n)
for (i in 1:(n-1)){
m1=data[i,]

for (j in i:n){
m2=data[j,]

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

dd[i,j]=eq11
dd[j,i]=dd[i,j]
}
}

#distancias a datos mas cercanos a E

dot=matrix(0,nrow=n,ncol=K)
for (i in 1:n){

m1=data[i,]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

dot[i,j]=eq11

}
}

mt[RE,1]=min(dot[,1])
mt[RE,2]=min(dot[,2])
mt[RE,3]=min(dot[,3])


#########cmdscale
md=cmdscale(dd,k=2,eig=T)

 x=md$points
 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deon[i,j]=eq11

}
}


deow=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deow[i,j]=eq11

}
}

mnmds[RE,1]=min(deon[,1])
mnmds[RE,2]=min(deon[,2])
mnmds[RE,3]=min(deon[,3])

mwmds[RE,1]=min(deow[,1])
mwmds[RE,2]=min(deow[,2])
mwmds[RE,3]=min(deow[,3])


#sammon


xs=sammon(dd,k=2)

 x=xs$points
 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deon[i,j]=eq11

}
}


deow=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deow[i,j]=eq11

}
}

mnsa[RE,1]=min(deon[,1])
mnsa[RE,2]=min(deon[,2])
mnsa[RE,3]=min(deon[,3])

mwsa[RE,1]=min(deow[,1])
mwsa[RE,2]=min(deow[,2])
mwsa[RE,3]=min(deow[,3])

######
#isomds


xsm=isoMDS(dd,k=2)

x=xsm$points
 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deon[i,j]=eq11

}
}


deow=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deow[i,j]=eq11

}
}

mniso[RE,1]=min(deon[,1])
mniso[RE,2]=min(deon[,2])
mniso[RE,3]=min(deon[,3])

mwiso[RE,1]=min(deow[,1])
mwiso[RE,2]=min(deow[,2])
mwiso[RE,3]=min(deow[,3])


###########
#h-plot



p=princomp(dd)
v=p$loadings
pr=p$sdev
pv=cbind(pr[1]*v[1:(n),1],pr[2]*v[1:(n),2])

x=pv



 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deon[i,j]=eq11

}
}


deow=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deow[i,j]=eq11

}
}

mnh[RE,1]=min(deon[,1])
mnh[RE,2]=min(deon[,2])
mnh[RE,3]=min(deon[,3])

mwh[RE,1]=min(deow[,1])
mwh[RE,2]=min(deow[,2])
mwh[RE,3]=min(deow[,3])

########originales, raw data


 x=data
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deon[i,j]=eq11

}
}


deow=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deow[i,j]=eq11

}
}

mno[RE,1]=min(deon[,1])
mno[RE,2]=min(deon[,2])
mno[RE,3]=min(deon[,3])

mwo[RE,1]=min(deow[,1])
mwo[RE,2]=min(deow[,2])
mwo[RE,3]=min(deow[,3])


#lle


set.seed(2014)
 ck=calc_k(dd,m=2)
r=lle(dd,m=2,k= which.min(ck$rho))
x=r$Y
norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deon[i,j]=eq11

}
}


deow=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deow[i,j]=eq11

}
}

mnlle[RE,1]=min(deon[,1])
mnlle[RE,2]=min(deon[,2])
mnlle[RE,3]=min(deon[,3])

mwlle[RE,1]=min(deow[,1])
mwlle[RE,2]=min(deow[,2])
mwlle[RE,3]=min(deow[,3])

##########
#DIF



df=diffuse(dd,neigen=2)
x=df$X
 
 norep=20
set.seed(2014)
lass10 <- stepArchetypesMod(data=x,k=K,verbose=FALSE,nrep=norep) 
ai <- bestModel(lass10[[1]]) #archetypes
 
an6 <-  stepArchetypoids(K,TRUE,x,lass10,FALSE,K-1) #nearest archetypoids
aw6 <-  stepArchetypoids(K,FALSE,x,lass10,FALSE,K-1) #which alpha archetypoids

deon=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[an6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deon[i,j]=eq11

}
}


deow=matrix(0,nrow=K,ncol=K)
for (i in 1:K){

m1=data[aw6[[1]][i],]

for (j in 1:K){
m2=t(E[,j])

sy=xor(m1,m2); 

eq11=sum(sy)/d;   #ecuacin 11 de error binary Baddeley

deow[i,j]=eq11

}
}

mnd[RE,1]=min(deon[,1])
mnd[RE,2]=min(deon[,2])
mnd[RE,3]=min(deon[,3])

mwd[RE,1]=min(deow[,1])
mwd[RE,2]=min(deow[,2])
mwd[RE,3]=min(deow[,3])




cat("iteration = ", RE, "\n")

}

